.MODEL TINY			  ; Modele de mmoire tiny ( < 64k donc .COM)
.486				  ; instructions 80486 pour MOVSD

CODESEG				  ; Segment de code ici! (CS: @Code)
ORG 100h			  ; Le dbut du prog  256 octets dans le seg (.COM)

.STARTUP			  ; Dbut du prog
	MOV	AX, 0013h	  ; Mode vido 13h
	INT	10h		  ; Interrruption vido

	MOV	DX, 03C8h	  ; Port 3C8h (Digital Analog Converter)
	XOR	AX, AX		  ; AX  0
	OUT	DX, AL		  ; Pel Write (modification de palette)
	INC	DX		  ; 3C9h... 

	MOV	CX, 64		  ; Boucle 64x (0-123)
Rouge:
     OUT	DX, AL		  ; Attribut Red
	PUSH	AX		  ; Sauve AX
	 XOR	AL, AL		  ; 0
     OUT	DX, AL		  ; Green 0
 	 OUT	DX, AL		  ; Blue  0
	POP	AX		  ; Ramene AX
	INC	AX		  ; AX=AX+1
	LOOP	Rouge		  ; 64x...

	MOV	CX,64		  ; Meme chose (64-127)
Jaune:				  ; mais rouge + vert = jaune
	PUSH	AX
     MOV AL, 63
	 OUT	DX, AL
	POP	AX
 	 OUT	DX, AL
	PUSH	AX
	 XOR	AL, AL
	 OUT	DX, AL
	POP	AX
	INC 	AX
	LOOP	Jaune

	MOV	 CX, 63		  ; (128-191)
Blanc:				  ; On termine avec le blanc
	PUSH 	AX
	 MOV  	AL, 63
     OUT	DX, AL
	 OUT	DX, AL  
	POP	AX
	OUT	DX, AL
	LOOP	Blanc

	PUSH	0A000h		   ; Adresse vido
	POP	ES		   ; dans ES...
	MOV	randseed, 1234h    ; Initialise nombre alatoire
            
Main:
   	MOV	SI,OFFSET [screen] ; SI Pointe sur l'offset 0 de l'cran virtuel
	ADD	SI,31680	   ; 32000-320 (Dernire ligne)
	MOV	CX,320		   ; 320 pixels...

Foyer:
	CALL	Random             ; Couleur alatoire dans DX
	MOV	DS:[SI], DL	   ; DL (donc entre 0 et 255)
	INC	SI		   ; Prochain pixel
	DEC	CX		   ; Un loop de moins
	JNZ	Foyer	           ; Tant que pas 0, loop!

	MOV	CX,31680	   ; le dernire ligne est dj faite...
	MOV	SI,OFFSET [screen] ; Offset de l'cran virtuel...
	ADD	SI,320		   ; moins la dernire ligne	

Feu :
	XOR	AX, AX		   ; Calcul d'un pixel
	MOV	AL, DS:[SI]	   ; x+(x-1)+(x+1)+(y+320)/4
	ADD	AL, DS:[SI+1]	   ; x-1
	ADC	AH, 0
	ADD	AL, DS:[SI-1]      ; x+1
	ADC	AH, 0
	ADD	AL, DS:[SI+320]    ; y-1
	ADC	AH, 0
	SHR	AX,2
	JZ	Zero		   ; Si AX=0, pas de refroidissement
	DEC	AX		   ; sinon refroidi le feu...	

Zero : 
	MOV	DS:[SI-320],AL	   ; Affiche le pixel dans notre cran virtuel, 
	INC	SI		   ; une ligne plus haut donc -320 ... et next!
	DEC	CX		   ; ...et un de moins!	
	JNZ	Feu	           ; tant que pas 0, LOOP!

  	MOV	DX, 03DAh	   ; Attend la retrace verticale
	ret1:
	IN	AL, DX
	AND	AL, 08
	JNZ	ret1
	ret2:
	IN	AL, DX
	AND	AL, 08
	JZ 	ret2

	MOV	CX,7360            ; Copie tout sauf les 2 dernires lignes
	MOV	SI,OFFSET [screen] ; A partir de l'cran virtuelle
	MOV	DI,32000+640       ; Sur l'cran physique
	REP	MOVSD		   ; de DS:SI vers ES:DI (Data sur Screen, ES vers A000h)
    MOV AH,08
    INT 21h
;	MOV	AH,01              ; Touche au clavier?
;	INT	16h
    CMP AL, 13
	JZ	Main	           ; Si non, on loop!
                      
	MOV	AX,0003h 	   ; Si oui, alors mode texte
	INT	10h		   
	RET			   ; et retour au OS

Random          PROC NEAR	   ; Procdure nombre alatoire
    	MOV	AX,[RandSeed]
	MOV	DX,8405h
	MUL	DX
	INC 	AX
	MOV	[RandSeed],AX
	RET
Random          ENDP


DATASEG				   ; Segment DS, ici!
		
screen   	db 32000 dup   (?) ; cran virtuel de 32000 bytes (50% screen)
randseed 	dw 		?  ; Nombre alatoire 

END				   ; Fin